package ch4;

import java.awt.*;
import java.applet.*;
import java.net.*;

public class DoubleBufferedImage extends Applet {
    private Image dbImage;
    private Image originalImage;
    private int xLocation = 0;
    private int imageWidth, imageHeight;
    private Graphics dbImageGraphics;
    private String imageURLString = "file:images/peppers.png";

    public void init() {
	URL url = null;
	try {
	    url = new URL(imageURLString);
	}
	catch (MalformedURLException me) {
            showStatus("Malformed URL: " + me.getMessage());
        }

	originalImage = getImage(url);

	MediaTracker mt = new MediaTracker(this);
	mt.addImage(originalImage, 0);
	try {
	    mt.waitForID(0);
	}
	catch (InterruptedException ie) {
	}

	//don't need ImageObservers since the Image is already loaded
	imageWidth = originalImage.getWidth(null);
	imageHeight = originalImage.getHeight(null);

	dbImage = this.createImage(imageWidth, imageHeight);
	dbImageGraphics = dbImage.getGraphics();
    }

    public void update(Graphics g) {
	paint(g);
    }

    public void paint(Graphics g) {
	if (xLocation == imageWidth)
	    xLocation = 0;

	//anything drawn using the dbImagGraphics object is hidden
	dbImageGraphics.clearRect(0,0,imageWidth, imageHeight);
	dbImageGraphics.drawImage(originalImage, 0, 0, this);
	dbImageGraphics.setColor(Color.red);
	dbImageGraphics.fillOval(xLocation, imageHeight/2, 20, 20);

	//now dbImage's drawing area appears
	g.drawImage(dbImage,0,0,this);

	xLocation ++;
	repaint(10);
    }
}
