package ch4;

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.awt.image.ImageObserver;

/**
 * ImageLoaderApplet.java -- load and display image specified by imageURL
 */
public class ImageLoaderApplet extends Applet {
    private Image img;
    private String imageURLString = "file:images/peppers.png";

    public void init() {
	URL url;
	try {
	    // set imageURL here
	    url = new URL(imageURLString);
	    img = getImage(url);
	}
	catch (MalformedURLException me) {
	    showStatus("Malformed URL: " + me.getMessage());
	}
    }

    /**
     * overloaded method to prevent clearing drawing area 
     */
    public void update(Graphics g) {
	paint(g);
    }

    public void paint(Graphics g) {
	g.drawImage(img, 0, 0, this);
    }

    /**
     * Verbose version of ImageConsumer's imageUpdate method
     */
    public boolean imageUpdate(Image img, int flags,
                               int x, int y, int width, int height) {
        System.out.print("Flag(s): ");
        if ( (flags & ImageObserver.WIDTH) != 0) {
            System.out.print("WIDTH:("+width+") ");
	}

        if ( (flags & ImageObserver.HEIGHT) != 0) {
            System.out.print("HEIGHT:("+height+") ");
        }

        if ( (flags & ImageObserver.PROPERTIES) != 0) {
            System.out.print("PROPERTIES ");
        }

        if ( (flags & ImageObserver.SOMEBITS) != 0) {
            System.out.print("SOMEBITS("+x+","+y+")->(");
	    System.out.print(width+","+height+") ");
            repaint();
        }

        if ( (flags & ImageObserver.FRAMEBITS) != 0) {
            System.out.print("FRAMEBITS("+x+","+y+")->(");
	    System.out.print(width+","+height+") ");
            repaint();
        }

        if ( (flags & ImageObserver.ALLBITS) != 0) {
            System.out.print("ALLBITS("+x+","+y+")->(");
	    System.out.println(width+","+height+") ");
            repaint();
            return false;
        }

        if ( (flags & ImageObserver.ABORT) != 0) {
            System.out.println("ABORT \n");
            return false;
        }

        if ( (flags & ImageObserver.ERROR) != 0) {
            System.out.println("ERROR ");
            return false;
        }

        System.out.println();
        return true;
    }
}
