package ch6;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;
import javax.media.jai.OperationRegistry;
import javax.media.jai.registry.RIFRegistry;
import java.awt.image.renderable.RenderedImageFactory;
import java.awt.image.renderable.ParameterBlock;
import ch6.checkalignment.*;

public class CheckAlignmentTester extends JFrame{

    /*
      The following static block registers the "CheckAlignment" operator
      with the JAI registry
    */
    static {
	OperationRegistry or;
	or = JAI.getDefaultInstance().getOperationRegistry();
	or.registerDescriptor(new CheckAlignmentDescriptor());
	RenderedImageFactory rif = new CheckAlignmentRIF();
	RIFRegistry.register(or, "CheckAlignment", "ch6example", rif);
    }

    public CheckAlignmentTester(String fileName1, 
				String fileName2, 
				String samplingPeriod) {
	pb = new ParameterBlock();
	pb.add(fileName1);
	RenderedOp sourceImage1 = JAI.create("fileload", pb);
	pb.set(fileName2,0);
	RenderedOp sourceImage2 = JAI.create("fileload", pb);

	pb = new ParameterBlock();
	pb.addSource(sourceImage1);
	pb.addSource(sourceImage2);
	pb.add(Integer.parseInt(samplingPeriod));
	RenderedOp destinationImage = JAI.create("CheckAlignment", pb);

	getContentPane().add(new ch6Display(destinationImage));

	pack();
	show();
    }

    public static void main(String[] args) {
	if (args.length != 3) {
	    System.err.print("Usage:  CheckAlignment ");
	    System.err.println("filename1 filename2 samplingPeriod");
	}
	else
	    new CheckAlignmentTester(args[0], args[1], args[2]);
    }
    private ParameterBlock pb;
}
