package ch6;

import java.awt.*;
import javax.swing.*;
import java.awt.image.renderable.ParameterBlock;
import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;

/**
   Intro.java -- objects of this class perform the following steps:
   1.  reads an image file
   2.  scales the image dimensions using provided scale factor
   3.  displays the result
*/
public class Intro extends JFrame {

    public Intro(String filename, String scaleFactor) {
	ParameterBlock pb;

	/*
	  create new ParameterBlock,
	  add filename parameter,
	  create RenderedOp
	*/
	pb = new ParameterBlock();
	pb.add(filename);
	RenderedOp inputRO = JAI.create("fileload", pb);

	/*
	  create new ParameterBlock, 
	  add a source and add a scale parameter,
	  create RenderedOp
	*/
	pb = new ParameterBlock();
	pb.addSource(inputRO);
	float scale = Float.parseFloat(scaleFactor);
	pb.add(scale); // x dimension scale factor
	pb.add(scale); // y dimension scale factor
	RenderedOp scaledRO = JAI.create("scale", pb);

	// display result
	getContentPane().add(new ch6Display(scaledRO));
	pack();
	show();
    }

    public static void main(String[] args) {
	if (args.length != 2)
	    System.err.println("Usage:  filename scaleFactor");
	else
	    new Intro(args[0], args[1]);
    }
}
