package ch6;

import java.awt.*;
import javax.swing.*;
import java.awt.image.renderable.ParameterBlock;
import javax.media.jai.remote.RemoteJAI;
import javax.media.jai.remote.RemoteRenderedOp;
/**
   RemoteTester.java -- takes as parameters a remote host and a
   filename.  It then reads and displays the image contained in this
   remote file.  
*/
public class RemoteTester extends JFrame {

    public RemoteTester(String serverName, String fileName) {
	ParameterBlock pb;
	String protocolName = "jairmi";
	RemoteJAI rc = new RemoteJAI(protocolName, serverName);

        // Create the operations to load the images from files.
	pb = new ParameterBlock();
	pb.add(fileName);
	pb.add(null);
	pb.add(Boolean.FALSE);
        RemoteRenderedOp remoteImage = rc.create("fileload", pb, null);

	getContentPane().add(new ch6Display(remoteImage));

	pack();
	show();
    }

    public static void main(String[] args) {
	if (args.length == 2) 
	    new RemoteTester(args[0], args[1]);
	else 
	    System.err.println("Usage:  RemoteTester serverName fileName");
    }
}
